# Perplex+

[![version](https://img.shields.io/badge/version-TODO-blue)](package.json)

Perplex+ is a library that allows easier access to [Perplexity AI](https://www.perplexity.ai/) UI.

## Installation

1. Install a userscript manager like [Violentmonkey](https://violentmonkey.github.io/)
2. Install the Perplex+ script

## Development

### Prerequisites

- [Bun](https://bun.sh/) (recommended) or Node.js
- [Vite](https://vitejs.dev/)

### Scripts

```bash
# Development
bun run dev

# Build
bun run build

# Generate documentation
bun run docs

# Watch and regenerate documentation on changes
bun run docs:watch

# Serve documentation locally with working navigation
bun run docs:serve
```

## Documentation

The project uses TypeDoc to generate API documentation. Documentation is automatically generated and deployed via GitLab CI/CD pipeline.

To generate documentation locally:

```bash
bun run docs
```

To view documentation locally with working navigation:

```bash
bun run docs:serve
```

Online documentation is available at: `monnef.gitlab.io/perplex-plus`

## Technical Details

### Dependencies

- jQuery
- Vite
- TypeScript

### Architecture

The project is structured as:

- `src/main.ts`: Dev/debug userscript
- `src/lib.ts`: Core library exposing helper functions

### Selectors

- primarily prompt areas
- left panel
- home widgets
- image generation overlay
- code blocks
- response cards

## License

AGPL 3.0
